"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.CameraModuleView = exports.CameraModule = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const LINKING_ERROR = `The package 'react-native-camera-module' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n';
const ComponentName = 'CameraModuleView';
const CameraModuleView = _reactNative.UIManager.getViewManagerConfig(ComponentName) != null ? (0, _reactNative.requireNativeComponent)(ComponentName) : () => {
  throw new Error(LINKING_ERROR);
};
exports.CameraModuleView = CameraModuleView;
const CameraModule = _reactNative.NativeModules.CameraModuleViewManager;
exports.CameraModule = CameraModule;
const CameraView = /*#__PURE__*/(0, _react.forwardRef)((_ref, parentRef) => {
  let {
    torch,
    device,
    style,
    zoom,
    deviceType
  } = _ref;
  const ref = (0, _react.useRef)();

  const handle = () => {
    const nodeHandle = (0, _reactNative.findNodeHandle)(ref === null || ref === void 0 ? void 0 : ref.current);

    if (nodeHandle == null || nodeHandle === -1) {
      throw new Error('system/view-not-found' + "Could not get the Camera's native view tag! Does the Camera View exist in the native view-tree?");
    }

    return nodeHandle;
  };

  (0, _react.useImperativeHandle)(parentRef, () => ({
    start: () => {
      const nodeHandle = handle();
      CameraModule.start(nodeHandle);
    },
    stop: () => {
      const nodeHandle = handle();
      CameraModule.stop(nodeHandle);
    },
    record: options => {
      const nodeHandle = handle();
      CameraModule.startRecording(nodeHandle, options, response => {
        options.recordingCallback(response);
      });
    },
    pause: () => {
      const nodeHandle = handle();
      CameraModule.pauseRecording(nodeHandle);
    },
    finish: () => {
      const nodeHandle = handle();
      CameraModule.stopRecording(nodeHandle);
    },
    getSupportedDevices: (devicePosition, callback) => {
      const nodeHandle = handle();
      return CameraModule.getDevices(nodeHandle, devicePosition, callback);
    }
  }));
  return /*#__PURE__*/_react.default.createElement(CameraModuleView, {
    ref: ref,
    device: device,
    torch: torch,
    style: style ? style : {},
    zoom: zoom,
    deviceType: deviceType
  });
});
var _default = CameraView;
exports.default = _default;
//# sourceMappingURL=CameraView.js.map