import React from 'react';
import { ViewStyle } from 'react-native';
export interface CameraViewProps {
    torch?: 'on' | 'off' | 'auto';
    device?: 'back' | 'front';
    style?: ViewStyle;
    zoom?: string;
    deviceType: 'ultra-wide-angle-camera' | 'wide-angle-camera' | '';
    ref: any;
}
export interface RecordingOptions {
    maxDuration: number;
    saveToCameraRoll: boolean;
    recordingCallback: (recordingResponse: RecordingResponse) => void;
}
export interface RecordingResponse {
    isSuccessful: boolean;
    path: string;
    error: string;
}
export interface RefMethods {
    start: () => void;
    stop: () => void;
    record: (options: RecordingOptions) => void;
    pause: () => void;
    finish: () => void;
    getSupportedDevices: (devicePosition: string, callback: any) => string[];
}
declare type CameraModuleProps = {
    style: ViewStyle;
    device?: 'back' | 'front';
    flash?: 'on' | 'off' | 'auto';
    torch?: 'on' | 'off' | 'auto';
    zoom?: string;
    deviceType: string;
    ref?: any;
};
export declare const CameraModuleView: import("react-native").HostComponent<CameraModuleProps> | (() => never);
export declare const CameraModule: any;
declare const CameraView: React.FC<CameraViewProps>;
export default CameraView;
